
'$DYNAMIC
DEFINT A-Z

DECLARE SUB MessageBox ()
DECLARE SUB SendMessage (objectnumber%, MessageData%)
DECLARE SUB ActivateRadius (objectnumber%, MessageNum%)
DECLARE SUB ExecuteScript (objectnumber%)
DECLARE SUB TransBox (TopLeftX%, TopLeftY%, BottomRightX%, BottomRightY%, TransType%)
DECLARE SUB LoadMap ()
DECLARE SUB Display (array%(), MapX%, MapY%, MaxX%, MaxY%, displayer%)
DECLARE SUB UpdateObjects (layer%)
DECLARE SUB MoveObject (objectnumber%, pixelmovesX%, pixelmovesY%)
DECLARE FUNCTION MoveObjectHelper% (O%, OX%, OY%, OXO%, OYO%, X%, Y%, XO%, YO%, ThisMapLevel() AS INTEGER)
DECLARE SUB CenterCamera ()
DECLARE SUB FontPrint (textstring$, X%, Y%)
DECLARE SUB BloadX (file$, SGment%, Offset%, NumBytes!, FilePointer!)
DECLARE SUB Keys ()
DECLARE SUB LoadTiles ()
DECLARE SUB Intro ()
DECLARE SUB ScreenX (modenumber%)
DECLARE SUB LoadPal (filename$)
DECLARE SUB Copy13h ()
DECLARE SUB put13h (BYVAL OBJSegm%, BYVAL OBJOffs%, BYVAL X%, BYVAL Y%, BYVAL Col%)
DECLARE SUB SetSegments13h (BYVAL SSegm%, BYVAL DSegm%)
DECLARE SUB initkbd ALIAS "installisr" (BYVAL arrayseg%, BYVAL arrayofs%)
DECLARE SUB deinitkbd ALIAS "removeisr" ()
DECLARE SUB BsaveX (file$, SGment, Offset%, NumBytes!, FilePointer!)
DECLARE SUB BloadX (file$, SGment, Offset%, NumBytes!, FilePointer!)
TYPE RegTypeX
 ax AS INTEGER
 bx AS INTEGER
 cx AS INTEGER
 dx AS INTEGER
 bp AS INTEGER
 si AS INTEGER
 di AS INTEGER
 flags AS INTEGER
 ds AS INTEGER
 es AS INTEGER
END TYPE
DECLARE SUB INTERRUPTX (intnum AS INTEGER, inreg AS RegTypeX, outreg AS RegTypeX)

DIM SHARED regs AS RegTypeX

TYPE ObjectScript
 Script AS STRING * 1000
 bytestowait AS INTEGER
 backtobyte AS INTEGER
 currentbyte AS INTEGER
 ScriptIsRunning AS INTEGER
END TYPE

TYPE KeyBoardProfile
 LeftArrow AS INTEGER
 RightArrow AS INTEGER
 UpArrow AS INTEGER
 DownArrow AS INTEGER
 Use AS INTEGER
 Status AS INTEGER
 Console AS INTEGER
 FastQuit AS INTEGER
 AskQuit AS INTEGER
 ScrollDown AS INTEGER
 Scrollup AS INTEGER
 CloseMessage AS INTEGER
 Running AS INTEGER
END TYPE

TYPE TileTableData
 AnimationFrames AS INTEGER
 AnimationDelayFrames AS INTEGER
 Segment AS INTEGER
 Offset AS INTEGER
END TYPE

TYPE ObjectData
 CharSetTile AS INTEGER
 MoveToX AS INTEGER
 MoveToY AS INTEGER
 ismoving AS INTEGER
 CurrentLayer AS INTEGER
 MapLocationX AS INTEGER
 MapLocationY AS INTEGER
 PixelLocationX AS INTEGER
 PixelLocationY AS INTEGER
 XAxisDirection AS INTEGER
 YAxisDirection AS INTEGER
 ActivatesScript AS INTEGER
 AnimationFrames AS INTEGER
 AnimationDelay AS INTEGER
 ObjectType AS INTEGER
 Steps AS LONG
 TileNumber AS INTEGER
 Stepping AS INTEGER
END TYPE

TYPE PlayerData
 PlayerName AS STRING * 16
 HitPoints AS INTEGER
 HitPointsMax AS INTEGER
 Strength AS INTEGER
 Endurance AS INTEGER
 Health AS INTEGER
END TYPE

CONST TRUE = -1
CONST FALSE = 0
CONST TransColor = 48

DIM SHARED MoveX
DIM SHARED MoveY
DIM SHARED ReasonToQuit
DIM SHARED CameraX, CameraY, CenteredCameraX, CenteredCameraY
DIM SHARED tiles(32759)
DIM SHARED tiledata(503) AS TileTableData
DIM SHARED VSYNC
DIM SHARED MapLevel1(89, 89, 1)
DIM SHARED maplevel2(89, 89, 1)
DIM SHARED maplevel3(89, 89, 1)
DIM SHARED KeyboardBuffer(255)
DIM SHARED Keyboard AS KeyBoardProfile
DIM SHARED bottombar(1281)
DIM SHARED Frames&
DIM SHARED buffer(31999)
DIM SHARED TextMessage(90) AS STRING * 38
DIM SHARED MessageBoxEnabled, MessageBoxLines, MessageBoxPositionY
DIM SHARED font(4351)
DIM SHARED CharSet(3095, 4)
DIM SHARED StartTime!
DIM SHARED flagnpc(63) AS INTEGER
DIM SHARED foundnpcs AS INTEGER
DIM SHARED Objects(63) AS ObjectData
DIM SHARED transpal(255)
DIM SHARED scripts(63) AS ObjectScript
DIM SHARED DirectionData(-1 TO 1, -1 TO 1)


RANDOMIZE TIMER
SetSegments13h VARSEG(buffer(0)), &HA000

'IF INSTR(UCASE$(COMMAND$), "wait") THEN VSYNC = 1
VSYNC = 1
ScreenX 19

Intro

LoadPal "qb.pal"
LoadTiles
LoadMap

FOR i = 0 TO 89
 FOR J = 0 TO 89
  MapLevel1(i, J, 1) = -1
  maplevel2(i, J, 1) = -1
  maplevel3(i, J, 1) = -1
 NEXT J
NEXT i

FOR i = 0 TO 63
 Objects(i).ObjectType = -1
NEXT i


'
' Player Data
'

Objects(0).CharSetTile = 0
Objects(0).ObjectType = 1
Objects(0).CurrentLayer = 0
Objects(0).PixelLocationX = 48
Objects(0).PixelLocationY = 48
MapLevel1(3, 3, 1) = 0

'
' Object 1 Data
'

Objects(1).CharSetTile = 1
Objects(1).ObjectType = 2
Objects(1).CurrentLayer = 0
Objects(1).PixelLocationX = 256
Objects(1).PixelLocationY = 176
scripts(1).backtobyte = 1
scripts(1).currentbyte = 1
scripts(1).ScriptIsRunning = 1
scriptpart$ = CHR$(4) + CHR$(0) + CHR$(255)
scriptpart$ = scriptpart$ + STRING$(127 - LEN(scriptpart$), CHR$(255))
scriptpart$ = scriptpart$ + CHR$(5) + CHR$(0) + CHR$(0) + CHR$(255)
scripts(1).Script = scriptpart$
MapLevel1(Objects(1).PixelLocationX \ 16, Objects(1).PixelLocationY \ 16, 1) = 1

'
' Object 2 Data
'


Objects(2).CharSetTile = -1
Objects(2).TileNumber = 4
Objects(2).ObjectType = 1
Objects(2).CurrentLayer = 0
Objects(2).PixelLocationX = 240
Objects(2).PixelLocationY = 176
scripts(2).backtobyte = 1
scripts(2).currentbyte = 1
scripts(2).ScriptIsRunning = 1
scriptpart$ = CHR$(255)
scriptpart$ = scriptpart$ + STRING$(127 - LEN(scriptpart$), CHR$(255))
scriptpart$ = scriptpart$ + CHR$(5) + CHR$(0) + CHR$(1) + CHR$(255)
scripts(2).Script = scriptpart$
MapLevel1(Objects(2).PixelLocationX \ 16, Objects(2).PixelLocationY \ 16, 1) = 2

'
' Object 3 Data
'


Objects(3).CharSetTile = -1
Objects(3).TileNumber = 4
Objects(3).ObjectType = 1
Objects(3).CurrentLayer = 0
Objects(3).PixelLocationX = 160
Objects(3).PixelLocationY = 336
scripts(3).backtobyte = 1
scripts(3).currentbyte = 1
scripts(3).ScriptIsRunning = 1
scriptpart$ = CHR$(255)
scriptpart$ = scriptpart$ + STRING$(127 - LEN(scriptpart$), CHR$(255))
scriptpart$ = scriptpart$ + CHR$(5) + CHR$(0) + CHR$(2) + CHR$(255)
scripts(3).Script = scriptpart$
MapLevel1(Objects(3).PixelLocationX \ 16, Objects(3).PixelLocationY \ 16, 1) = 3



'
' Object 4 Data
'


Objects(4).CharSetTile = -1
Objects(4).TileNumber = 2
Objects(4).ObjectType = 1
Objects(4).CurrentLayer = 0
Objects(4).PixelLocationX = 160
Objects(4).PixelLocationY = 400
scripts(4).backtobyte = 1
scripts(4).currentbyte = 1
scripts(4).ScriptIsRunning = 1
scriptpart$ = CHR$(255)
scriptpart$ = scriptpart$ + STRING$(127 - LEN(scriptpart$), CHR$(255))
scriptpart$ = scriptpart$ + CHR$(2) + CHR$(10) + CHR$(25) + CHR$(2) + CHR$(8) + CHR$(25)
scriptpart$ = scriptpart$ + CHR$(6) + CHR$(1) + CHR$(1) + CHR$(9) + CHR$(25)
scriptpart$ = scriptpart$ + CHR$(5) + CHR$(0) + CHR$(3) + CHR$(255)
scripts(4).Script = scriptpart$
MapLevel1(Objects(4).PixelLocationX \ 16, Objects(4).PixelLocationY \ 16, 1) = 4






FOR i = 0 TO 251
 tiledata(i).Segment = VARSEG(tiles(130 * i))
 tiledata(i).Offset = VARPTR(tiles(130 * i))
 tiledata(i + 252).Segment = VARSEG(tiles(130 * i))
 tiledata(i + 252).Offset = VARPTR(tiles(130 * i))
 tiledata(i + 252).AnimationFrames = 1
 tiledata(i + 252).AnimationDelayFrames = 4
 tiledata(i).AnimationFrames = 1
 tiledata(i).AnimationDelayFrames = 4
NEXT i


Keyboard.UpArrow = 72
Keyboard.DownArrow = 80
Keyboard.LeftArrow = 75
Keyboard.RightArrow = 77
Keyboard.FastQuit = 1
Keyboard.ScrollDown = 81
Keyboard.Scrollup = 73
Keyboard.CloseMessage = 79
Keyboard.Running = 44

DirectionData(-1, -1) = 2322
DirectionData(-1, 0) = 1548
DirectionData(-1, 1) = 0

DirectionData(0, -1) = 2322
DirectionData(0, 0) = 0
DirectionData(0, 1) = 0

DirectionData(1, -1) = 2322
DirectionData(1, 0) = 774
DirectionData(1, 1) = 774


tiledata(8).AnimationFrames = 2
tiledata(8).AnimationDelayFrames = 20
tiledata(35).AnimationFrames = 3
tiledata(35).AnimationDelayFrames = 5

initkbd VARSEG(KeyboardBuffer(0)), VARPTR(KeyboardBuffer(0))

StartTime! = TIMER
DO
 Frames& = Frames& + 1
 UpdateObjects 0
 UpdateObjects 1
 UpdateObjects 2
 CameraX = Objects(0).PixelLocationX + 8
 CameraY = Objects(0).PixelLocationY + 8
 CenterCamera
 Display MapLevel1(), CenteredCameraX, CenteredCameraY, 19, 11, 0
 Display maplevel2(), CenteredCameraX, CenteredCameraY, 19, 11, 1
 Display maplevel3(), CenteredCameraX, CenteredCameraY, 19, 11, 2
 put13h VARSEG(bottombar(0)), VARPTR(bottombar(0)), 0, 192, -1
 IF MessageBoxEnabled THEN MessageBox
 IF VSYNC THEN WAIT &H3DA, 8
 Copy13h
 ReasonToQuit = KeyboardBuffer(Keyboard.FastQuit)
LOOP UNTIL ReasonToQuit
StopTime! = TIMER

deinitkbd

ScreenX 3
IF StartTime! > StopTime! THEN StopTime! = StopTime! + 86400
IF StartTime! <> StopTime! THEN PRINT USING "###.## fps"; Frames& / (StopTime! - StartTime!)
PRINT "QbProgger Engine v2"
PRINT "by QbProgger"
PRINT "Assembly PUT/MEMCOPY routine by XlatB"
PRINT "Assembly keyboard ISR by LogicLord"
PRINT "some assistance by LogicLord with collision detection"

REM $STATIC
SUB ActivateRadius (objectnumber, MessageNum)
MapPositionX = (Objects(objectnumber).PixelLocationX \ 16) + Objects(objectnumber).XAxisDirection
MapPositionY = (Objects(objectnumber).PixelLocationY \ 16) + Objects(objectnumber).YAxisDirection

IF MapPositionX < 0 OR MapPositionX > 89 OR MapPositionY < 0 OR MapPositionY > 89 THEN EXIT SUB
CurrentTEstLayer = Objects(objectnumber).CurrentLayer

SELECT CASE CurrentTEstLayer
CASE 0
TestMap = MapLevel1(MapPositionX, MapPositionY, 1)
CASE 1
TestMap = maplevel2(MapPositionX, MapPositionY, 1)
CASE 2
TestMap = maplevel3(MapPositionX, MapPositionY, 1)
END SELECT
IF ((TestMap <> objectnumber) AND (TestMap <> -1)) THEN SendMessage TestMap, MessageNum
END SUB

SUB BloadX (file$, SGment, Offset, NumBytes!, FilePointer!)

file$ = file$ + CHR$(0) 'must have a NULL for int to terminate.
regs.ax = &H3D00
regs.ds = VARSEG(file$) 'segment of name
regs.dx = SADD(file$)  'offset of name
CALL INTERRUPTX(&H21, regs, regs)
regs.bx = regs.ax 'filehandle

regs.ax = &H4200
regs.cx = VAL("&H" + HEX$(INT(FilePointer! / 65536)))
regs.dx = VAL("&H" + HEX$(FilePointer! MOD 65536))
CALL INTERRUPTX(&H21, regs, regs)

regs.ax = &H3F00
regs.cx = VAL("&H" + HEX$(NumBytes!))
regs.ds = VAL("&H" + HEX$(SGment))
regs.dx = VAL("&H" + HEX$(Offset))
CALL INTERRUPTX(&H21, regs, regs)

regs.ax = &H3E00
CALL INTERRUPTX(&H21, regs, regs)

END SUB

SUB BsaveX (file$, SGment, Offset, NumBytes!, FilePointer!)

OPEN file$ FOR BINARY AS #1
CLOSE #1

file$ = file$ + CHR$(0)
regs.ax = &H3D01
regs.ds = VARSEG(file$)  'segment of filename
regs.dx = SADD(file$) 'offset of filename
CALL INTERRUPTX(&H21, regs, regs)
regs.bx = regs.ax 'filehandle

regs.ax = &H4200
regs.cx = VAL("&H" + HEX$(INT(FilePointer! / 65536)))
regs.dx = VAL("&H" + HEX$(FilePointer! MOD 65536))
CALL INTERRUPTX(&H21, regs, regs)

'saves the screen into the file
regs.ax = &H4000
regs.cx = VAL("&H" + HEX$(NumBytes!))
regs.ds = VAL("&H" + HEX$(SGment))
regs.dx = VAL("&H" + HEX$(Offset))
CALL INTERRUPTX(&H21, regs, regs)

'close the file
regs.ax = &H3E00
CALL INTERRUPTX(&H21, regs, regs)

END SUB

SUB CenterCamera
CenteredCameraX = CameraX - 160
CenteredCameraY = CameraY - 100
IF CenteredCameraX < 0 THEN CenteredCameraX = 0
IF CenteredCameraY < 0 THEN CenteredCameraY = 0
IF CenteredCameraY > 1248 THEN CenteredCameraY = 1248
IF CenteredCameraX > 1120 THEN CenteredCameraX = 1120
END SUB

SUB Display (array(), MapX, MapY, MaxX, MaxY, displayer)
foundnpcs = 0
FOR cleararray = 0 TO 63
flagnpc(cleararray) = 0
NEXT


StartX = -(MapX AND 15)
Starty = -(MapY AND 15)
StartMapX = MapX \ 16
StartMapY = MapY \ 16
LocationX = StartX
EndX = MaxX - SGN(StartX)
endy = MaxY - SGN(Starty)
FOR showx = 0 TO EndX
 LocationY = Starty
 FOR showy = 0 TO endy
  til = array(StartMapX + showx, StartMapY + showy, 0)
  IF tiledata(til).AnimationFrames <> 1 THEN til = til + ((Frames& \ tiledata(til).AnimationDelayFrames) MOD (tiledata(til).AnimationFrames))
  IF til <> 0 THEN put13h tiledata(til).Segment, tiledata(til).Offset, LocationX, LocationY, 0
 LocationY = LocationY + 16
 NEXT
 LocationX = LocationX + 16
 NEXT

'Object Displaying routine
FOR showx = 0 TO EndX
FOR showy = 0 TO endy + 1
SELECT CASE displayer
CASE 0
ObjectTest = MapLevel1(StartMapX + showx, StartMapY + showy, 1)
CASE 1
ObjectTest = maplevel2(StartMapX + showx, StartMapY + showy, 1)
CASE 2
ObjectTest = maplevel3(StartMapX + showx, StartMapY + showy, 1)
END SELECT
IF ObjectTest > -1 THEN
IF Objects(ObjectTest).ObjectType > -1 THEN
junkvar = DirectionData(Objects(ObjectTest).XAxisDirection, Objects(ObjectTest).YAxisDirection) + (Objects(ObjectTest).Stepping * 258)
SELECT CASE Objects(ObjectTest).CharSetTile
CASE -1
put13h tiledata(Objects(ObjectTest).TileNumber).Segment, tiledata(Objects(ObjectTest).TileNumber).Offset, Objects(ObjectTest).PixelLocationX - MapX, Objects(ObjectTest).PixelLocationY - MapY, 0
CASE ELSE
put13h VARSEG(CharSet(junkvar, Objects(ObjectTest).CharSetTile)), VARPTR(CharSet(junkvar, Objects(ObjectTest).CharSetTile)), Objects(ObjectTest).PixelLocationX - MapX, Objects(ObjectTest).PixelLocationY - MapY - 16, 0
'put13h VARSEG(CharSet(junkvar, 1)), VARPTR(CharSet(junkvar, 1)), Objects(ObjectTest).PixelLocationX - MapX, Objects(ObjectTest).PixelLocationY - MapY - 16, 0
END SELECT
END IF
END IF
NEXT showy, showx
END SUB

SUB ExecuteScript (objectnumber)
IF scripts(objectnumber).bytestowait > 0 THEN
scripts(objectnumber).bytestowait = scripts(objectnumber).bytestowait - 1
EXIT SUB
END IF
SELECT CASE Objects(objectnumber).ismoving
CASE 0

number = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
SELECT CASE number

CASE 0
scripts(objectnumber).ScriptIsRunning = 0
CASE 1

Objects(objectnumber).ObjectType = -1

SELECT CASE Objects(objectnumber).CurrentLayer
CASE 0
MapLevel1(Objects(objectnumber).PixelLocationX \ 16, Objects(objectnumber).PixelLocationY \ 16, 1) = -1
CASE 1
maplevel2(Objects(objectnumber).PixelLocationX \ 16, Objects(objectnumber).PixelLocationY \ 16, 1) = -1
CASE 2
maplevel3(Objects(objectnumber).PixelLocationX \ 16, Objects(objectnumber).PixelLocationY \ 16, 1) = -1
END SELECT

CASE 2
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
Objects(objectnumber).MoveToX = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
Objects(objectnumber).MoveToY = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
Objects(objectnumber).ismoving = 1
CASE 3
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
scripts(objectnumber).bytestowait = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
CASE 4
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
LookNum = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
Objects(objectnumber).XAxisDirection = SGN(Objects(LookNum).PixelLocationX - Objects(objectnumber).PixelLocationX)
Objects(objectnumber).YAxisDirection = SGN(Objects(LookNum).PixelLocationY - Objects(objectnumber).PixelLocationY)
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
CASE 5
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
MsgNumb1 = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
MsgNumb2 = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
MessageBoxEnabled = 1
MessageBoxPositionY = 0
OPEN "Mes" + LTRIM$(RTRIM$(STR$((MsgNumb1 * 256) + MsgNumb2))) + ".spk" FOR INPUT AS #3
INPUT #3, MessageBoxLines
SELECT CASE MessageBoxLines
CASE IS < 8
FOR wipetext = 0 TO 7: TextMessage(wipetext) = "": NEXT
END SELECT
FOR getmessage = 0 TO MessageBoxLines
INPUT #3, TextMessage(getmessage)
NEXT
CLOSE #3
CASE 6
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
TileFlag = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
TileNum = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
TileX = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
TileY = ASC(MID$(scripts(objectnumber).Script, scripts(objectnumber).currentbyte, 1))
scripts(objectnumber).currentbyte = scripts(objectnumber).currentbyte + 1
MapLevel1(TileX, TileY, 0) = TileNum + (TileFlag * 252)
CASE 255
scripts(objectnumber).currentbyte = scripts(objectnumber).backtobyte
scripts(objectnumber).backtobyte = 1
END SELECT


CASE 1
keyx = SGN((Objects(objectnumber).MoveToX * 16) - Objects(objectnumber).PixelLocationX)
keyy = SGN((Objects(objectnumber).MoveToY * 16) - Objects(objectnumber).PixelLocationY)
MoveObject objectnumber, keyx, 0
MoveObject objectnumber, 0, keyy
Objects(objectnumber).XAxisDirection = keyx
Objects(objectnumber).YAxisDirection = keyy

IF Objects(objectnumber).MoveToY * 16 = Objects(objectnumber).PixelLocationY THEN
IF Objects(objectnumber).MoveToX * 16 = Objects(objectnumber).PixelLocationX THEN
Objects(objectnumber).ismoving = 0
END IF
END IF

END SELECT

END SUB

SUB FontPrint (textstring$, X, Y)
FOR i = 1 TO LEN(textstring$)
 til = 34 * ASC(MID$(textstring$, i, 1))
 put13h VARSEG(font(til)), VARPTR(font(til)), X + (i * 8), Y, 0
NEXT
END SUB

SUB Intro
LoadPal "cotr.pal"
BloadX "cotr.img", VARSEG(buffer(0)), 0, 64000, 0
Copy13h
dummy = INP(&H60)
DO: LOOP UNTIL INP(&H60) <> dummy
END SUB

SUB LoadMap
BloadX "MAP.DAT", VARSEG(MapLevel1(0, 0, 0)), VARPTR(MapLevel1(0, 0, 0)), 16200, 0
BloadX "MAP.DAT", VARSEG(maplevel2(0, 0, 0)), VARPTR(maplevel2(0, 0, 0)), 16200, 16200
BloadX "MAP.DAT", VARSEG(maplevel3(0, 0, 0)), VARPTR(maplevel3(0, 0, 0)), 16200, 32400
END SUB

SUB LoadPal (filename$)
FileNum = FREEFILE
OPEN filename$ FOR BINARY AS #FileNum
OUT &H3C8, 0
FOR i = 0 TO 255
a = ASC(INPUT$(1, FileNum))
OUT &H3C9, a
b = ASC(INPUT$(1, FileNum))
OUT &H3C9, b
c = ASC(INPUT$(1, FileNum))
OUT &H3C9, c
transpal(i) = (a + b + c) \ 16
NEXT
END SUB

SUB LoadTiles
DEF SEG = VARSEG(CharSet(0, 0))
BLOAD "char.put", VARPTR(CharSet(0, 0))
DEF SEG = VARSEG(tiles(0))
BLOAD "tiles.put", VARPTR(tiles(0))
DEF SEG = VARSEG(bottombar(0))
BLOAD "bottom.put", VARPTR(bottombar(0))
DEF SEG = VARSEG(font(0))
BLOAD "font.put", VARPTR(font(0))
DEF SEG
END SUB

SUB MessageBox
IF KeyboardBuffer(Keyboard.CloseMessage) THEN MessageBoxEnabled = 0: EXIT SUB
IF KeyboardBuffer(Keyboard.Scrollup) AND MessageBoxPositionY <> 0 THEN MessageBoxPositionY = MessageBoxPositionY - 1
IF KeyboardBuffer(Keyboard.ScrollDown) AND MessageBoxLines > 7 AND MessageBoxPositionY <> MessageBoxLines - 7 THEN MessageBoxPositionY = MessageBoxPositionY + 1
TransBox 0, 128, 319, 191, 0
FOR WriteText = 0 TO 7
FontPrint TextMessage(WriteText + MessageBoxPositionY), 0, 128 + (WriteText * 8)
NEXT WriteText
END SUB

SUB MoveObject (objectnumber, pixelmovesX, pixelmovesY)
checkidle = (ABS(pixelmovesX) + ABS(pixelmovesY))
IF checkidle > 0 THEN Objects(objectnumber).Steps = Objects(objectnumber).Steps + 1 ELSE EXIT SUB
Objects(objectnumber).Stepping = (Objects(objectnumber).Steps \ 16) AND 3
IF Objects(objectnumber).Stepping = 2 THEN Objects(objectnumber).Stepping = 0
IF Objects(objectnumber).Stepping = 3 THEN Objects(objectnumber).Stepping = 2
Objects(objectnumber).XAxisDirection = SGN(pixelmovesX)
Objects(objectnumber).YAxisDirection = SGN(pixelmovesY)
MapLayer = Objects(objectnumber).CurrentLayer
OX = (Objects(objectnumber).PixelLocationX) \ 16
OY = (Objects(objectnumber).PixelLocationY) \ 16
OXO = Objects(objectnumber).PixelLocationX AND 15
OYO = Objects(objectnumber).PixelLocationY AND 15
Objects(objectnumber).PixelLocationX = Objects(objectnumber).PixelLocationX + pixelmovesX
IF Objects(objectnumber).PixelLocationX < 0 THEN
 Objects(objectnumber).PixelLocationX = Objects(objectnumber).PixelLocationX - pixelmovesX
 EXIT SUB
END IF
Objects(objectnumber).PixelLocationY = Objects(objectnumber).PixelLocationY + pixelmovesY
IF Objects(objectnumber).PixelLocationY < 0 THEN
 Objects(objectnumber).PixelLocationY = Objects(objectnumber).PixelLocationY - pixelmovesY
 EXIT SUB
END IF
X = (Objects(objectnumber).PixelLocationX) \ 16
Y = (Objects(objectnumber).PixelLocationY) \ 16
XO = Objects(objectnumber).PixelLocationX AND 15
YO = Objects(objectnumber).PixelLocationY AND 15
IF (X < 0) OR (Y < 0) OR (X > 89) OR (Y > 89) THEN
 a% = 0
ELSE
 SELECT CASE MapLayer
  CASE 0: a% = MoveObjectHelper%(objectnumber, OX, OY, OXO, OYO, X, Y, XO, YO, MapLevel1())
  CASE 1: a% = MoveObjectHelper%(objectnumber, OX, OY, OXO, OYO, X, Y, XO, YO, maplevel2())
  CASE 2: a% = MoveObjectHelper%(objectnumber, OX, OY, OXO, OYO, X, Y, XO, YO, maplevel3())
 END SELECT
END IF
IF a% = 0 THEN
 Objects(objectnumber).PixelLocationX = Objects(objectnumber).PixelLocationX - pixelmovesX
 Objects(objectnumber).PixelLocationY = Objects(objectnumber).PixelLocationY - pixelmovesY
END IF
END SUB

'O = object number
'OX,OY = old map x,y
'OXO,OYO = old pixel x,y offset into tile (ie, 0 to 15)
'X,Y = new map x,y
'XO,YO = new pixel x,y offset into tile
'ThisMapLevel() = array for this map level
FUNCTION MoveObjectHelper% (O, OX, OY, OXO, OYO, X, Y, XO, YO, ThisMapLevel() AS INTEGER)
DetectedObject = 0
PX = Objects(O).PixelLocationX
PY = Objects(O).PixelLocationY
FOR i = -1 TO 1
 FOR J = -1 TO 1
  K = X + i
  L = Y + J
  IF (K >= 0) AND (L >= 0) AND (K <= 89) AND (L <= 89) THEN
   IF (ThisMapLevel(K, L, 1) + 1) AND (ThisMapLevel(K, L, 1) <> O) THEN
    IF ABS(PX - Objects(ThisMapLevel(K, L, 1)).PixelLocationX) <= 15 THEN
     IF ABS(PY - Objects(ThisMapLevel(K, L, 1)).PixelLocationY) <= 15 THEN
      EXIT FUNCTION
     END IF
    END IF
   END IF
  END IF
 NEXT J
NEXT i
IF (ThisMapLevel(X, Y, 0) > 251) AND (ThisMapLevel(X, Y, 0) < 504) THEN EXIT FUNCTION
IF (ThisMapLevel(X, Y, 1) + 1) AND (ThisMapLevel(X, Y, 1) <> O) THEN
 IF ABS(PX - Objects(ThisMapLevel(X, Y, 1)).PixelLocationX) <= 15 THEN
  IF ABS(PY - Objects(ThisMapLevel(X, Y, 1)).PixelLocationY) <= 15 THEN
   EXIT FUNCTION
  END IF
 END IF
END IF
IF XO THEN
 IF (ThisMapLevel(X + 1, Y, 0) > 251) AND (ThisMapLevel(X + 1, Y, 0) < 504) THEN EXIT FUNCTION
 IF (ThisMapLevel(X + 1, Y, 1) + 1) AND (ThisMapLevel(X + 1, Y, 1) <> O) THEN
  IF ABS(PX - Objects(ThisMapLevel(X + 1, Y, 1)).PixelLocationX) <= 15 THEN
   IF ABS(PY - Objects(ThisMapLevel(X + 1, Y, 1)).PixelLocationY) <= 15 THEN
    EXIT FUNCTION
   END IF
  END IF
 END IF
 IF YO THEN
  IF (ThisMapLevel(X + 1, Y + 1, 0) > 251) AND (ThisMapLevel(X + 1, Y + 1, 0) < 504) THEN EXIT FUNCTION
  IF (ThisMapLevel(X + 1, Y + 1, 1) + 1) AND (ThisMapLevel(X + 1, Y + 1, 1) <> O) THEN
   IF ABS(PX - Objects(ThisMapLevel(X + 1, Y + 1, 1)).PixelLocationX) <= 15 THEN
    IF ABS(PY - Objects(ThisMapLevel(X + 1, Y + 1, 1)).PixelLocationY) <= 15 THEN
     EXIT FUNCTION
    END IF
   END IF
  END IF
 END IF
END IF
IF YO THEN
 IF (ThisMapLevel(X, Y + 1, 0) > 251) AND (ThisMapLevel(X, Y + 1, 0) < 504) THEN EXIT FUNCTION
 IF (ThisMapLevel(X, Y + 1, 1) + 1) AND (ThisMapLevel(X, Y + 1, 1) <> O) THEN
  IF ABS(PX - Objects(ThisMapLevel(X, Y + 1, 1)).PixelLocationX) <= 15 THEN
   IF ABS(PY - Objects(ThisMapLevel(X, Y + 1, 1)).PixelLocationY) <= 15 THEN
    EXIT FUNCTION
   END IF
  END IF
 END IF
END IF
ThisMapLevel(OX, OY, 1) = -1
ThisMapLevel(X, Y, 1) = O
MoveObjectHelper% = -1
END FUNCTION

SUB ScreenX (modenumber)
regs.ax = modenumber
INTERRUPTX &H10, regs, regs
END SUB

SUB SendMessage (objectnumber, MessageData)
Objects(objectnumber).ismoving = 0
scripts(objectnumber).backtobyte = scripts(objectnumber).currentbyte
scripts(objectnumber).currentbyte = 128 + (MessageData * 64)
END SUB

SUB TransBox (TopLeftX, TopLeftY, BottomRightX, BottomRightY, TransType)
SELECT CASE TransType
CASE 0
DEF SEG = VARSEG(buffer(0))
IF TopLeftX < -15 THEN EXIT SUB
IF TopLeftX < 0 THEN TopLeftX = 0
IF TopLeftY < 0 THEN TopLeftY = 0
IF BottomRightX > 319 THEN BottomRightX = 319
IF BottomRightY > 191 THEN BottomRightY = 191
StartPosition& = TopLeftY * 320& + TopLeftX
FOR PlotY = 0 TO (BottomRightY - TopLeftY)
FOR PlotX = 0 TO (BottomRightX - TopLeftX)
junk = StartPosition& + PlotX
POKE junk, TransColor + transpal(PEEK(junk))
NEXT PlotX
StartPosition& = StartPosition& + 320
NEXT PlotY
CASE 1
DEF SEG = VARSEG(buffer(0))
IF TopLeftX < -15 THEN EXIT SUB
IF TopLeftX < 0 THEN TopLeftX = 0
IF TopLeftY < 0 THEN TopLeftY = 0
IF BottomRightX > 319 THEN BottomRightX = 319
IF BottomRightY > 191 THEN BottomRightY = 191
StartPosition& = TopLeftY * 320& + TopLeftX
FOR PlotY = 1 TO (BottomRightY - TopLeftY) - 1
FOR PlotX = 1 TO (BottomRightX - TopLeftX) - 1
POKE StartPosition& + PlotX, TransColor + (transpal(PEEK(StartPosition& + PlotX + 1)) + transpal(PEEK(StartPosition& + PlotX - 1)) + transpal(PEEK(StartPosition& + PlotX + 320)) + transpal(PEEK(StartPosition& + PlotX - 320))) \ 4
NEXT PlotX
StartPosition& = StartPosition& + 320
NEXT PlotY
END SELECT
END SUB

SUB UpdateObjects (layer)

FOR CheckObject = 0 TO 63

 IF Objects(CheckObject).ObjectType <> -1 THEN
  IF Objects(CheckObject).CurrentLayer = layer THEN
   SELECT CASE scripts(CheckObject).ScriptIsRunning
   CASE 0
   SELECT CASE Objects(CheckObject).ObjectType
    CASE 1:
     keyx = (KeyboardBuffer(Keyboard.RightArrow) - KeyboardBuffer(Keyboard.LeftArrow)) * (1 + KeyboardBuffer(Keyboard.Running))
     keyy = (KeyboardBuffer(Keyboard.DownArrow) - KeyboardBuffer(Keyboard.UpArrow)) * (1 + KeyboardBuffer(Keyboard.Running))
     MoveObject CheckObject, keyx, 0
     MoveObject CheckObject, 0, keyy
     IF KeyboardBuffer(57) THEN ActivateRadius CheckObject, 0
   END SELECT
  
   CASE 1
  
   ExecuteScript CheckObject
  
   END SELECT
  
  
   END IF
 END IF
NEXT
END SUB

